# coding: utf-8

# flake8: noqa

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails from dynamically allocated email addresses. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

__version__ = "15.11.1"

# import apis into sdk package
from mailslurp_client.api.alias_controller_api import AliasControllerApi
from mailslurp_client.api.attachment_controller_api import AttachmentControllerApi
from mailslurp_client.api.bounce_controller_api import BounceControllerApi
from mailslurp_client.api.bulk_actions_controller_api import BulkActionsControllerApi
from mailslurp_client.api.common_actions_controller_api import CommonActionsControllerApi
from mailslurp_client.api.contact_controller_api import ContactControllerApi
from mailslurp_client.api.domain_controller_api import DomainControllerApi
from mailslurp_client.api.email_controller_api import EmailControllerApi
from mailslurp_client.api.email_verification_controller_api import EmailVerificationControllerApi
from mailslurp_client.api.expired_controller_api import ExpiredControllerApi
from mailslurp_client.api.export_controller_api import ExportControllerApi
from mailslurp_client.api.form_controller_api import FormControllerApi
from mailslurp_client.api.group_controller_api import GroupControllerApi
from mailslurp_client.api.inbox_controller_api import InboxControllerApi
from mailslurp_client.api.inbox_forwarder_controller_api import InboxForwarderControllerApi
from mailslurp_client.api.inbox_ruleset_controller_api import InboxRulesetControllerApi
from mailslurp_client.api.mail_server_controller_api import MailServerControllerApi
from mailslurp_client.api.missed_email_controller_api import MissedEmailControllerApi
from mailslurp_client.api.phone_controller_api import PhoneControllerApi
from mailslurp_client.api.sent_emails_controller_api import SentEmailsControllerApi
from mailslurp_client.api.sms_controller_api import SmsControllerApi
from mailslurp_client.api.template_controller_api import TemplateControllerApi
from mailslurp_client.api.tracking_controller_api import TrackingControllerApi
from mailslurp_client.api.wait_for_controller_api import WaitForControllerApi
from mailslurp_client.api.webhook_controller_api import WebhookControllerApi

# import ApiClient
from mailslurp_client.api_client import ApiClient
from mailslurp_client.configuration import Configuration
from mailslurp_client.exceptions import OpenApiException
from mailslurp_client.exceptions import ApiTypeError
from mailslurp_client.exceptions import ApiValueError
from mailslurp_client.exceptions import ApiKeyError
from mailslurp_client.exceptions import ApiException
# import models into sdk package
from mailslurp_client.models.abstract_webhook_payload import AbstractWebhookPayload
from mailslurp_client.models.alias_dto import AliasDto
from mailslurp_client.models.alias_projection import AliasProjection
from mailslurp_client.models.attachment_entity import AttachmentEntity
from mailslurp_client.models.attachment_meta_data import AttachmentMetaData
from mailslurp_client.models.attachment_projection import AttachmentProjection
from mailslurp_client.models.basic_auth_options import BasicAuthOptions
from mailslurp_client.models.bounce_projection import BounceProjection
from mailslurp_client.models.bounce_recipient import BounceRecipient
from mailslurp_client.models.bounced_email_dto import BouncedEmailDto
from mailslurp_client.models.bounced_recipient_dto import BouncedRecipientDto
from mailslurp_client.models.bulk_send_email_options import BulkSendEmailOptions
from mailslurp_client.models.condition_option import ConditionOption
from mailslurp_client.models.contact_dto import ContactDto
from mailslurp_client.models.contact_projection import ContactProjection
from mailslurp_client.models.content_match_options import ContentMatchOptions
from mailslurp_client.models.count_dto import CountDto
from mailslurp_client.models.create_alias_options import CreateAliasOptions
from mailslurp_client.models.create_contact_options import CreateContactOptions
from mailslurp_client.models.create_domain_options import CreateDomainOptions
from mailslurp_client.models.create_emergency_address_options import CreateEmergencyAddressOptions
from mailslurp_client.models.create_group_options import CreateGroupOptions
from mailslurp_client.models.create_inbox_dto import CreateInboxDto
from mailslurp_client.models.create_inbox_forwarder_options import CreateInboxForwarderOptions
from mailslurp_client.models.create_inbox_ruleset_options import CreateInboxRulesetOptions
from mailslurp_client.models.create_template_options import CreateTemplateOptions
from mailslurp_client.models.create_tracking_pixel_options import CreateTrackingPixelOptions
from mailslurp_client.models.create_webhook_options import CreateWebhookOptions
from mailslurp_client.models.dns_lookup_options import DNSLookupOptions
from mailslurp_client.models.dns_lookup_result import DNSLookupResult
from mailslurp_client.models.dns_lookup_results import DNSLookupResults
from mailslurp_client.models.describe_domain_options import DescribeDomainOptions
from mailslurp_client.models.describe_mail_server_domain_result import DescribeMailServerDomainResult
from mailslurp_client.models.domain_dto import DomainDto
from mailslurp_client.models.domain_name_record import DomainNameRecord
from mailslurp_client.models.domain_preview import DomainPreview
from mailslurp_client.models.download_attachment_dto import DownloadAttachmentDto
from mailslurp_client.models.email import Email
from mailslurp_client.models.email_analysis import EmailAnalysis
from mailslurp_client.models.email_content_match_result import EmailContentMatchResult
from mailslurp_client.models.email_html_dto import EmailHtmlDto
from mailslurp_client.models.email_links_result import EmailLinksResult
from mailslurp_client.models.email_preview import EmailPreview
from mailslurp_client.models.email_preview_urls import EmailPreviewUrls
from mailslurp_client.models.email_projection import EmailProjection
from mailslurp_client.models.email_recipients import EmailRecipients
from mailslurp_client.models.email_text_lines_result import EmailTextLinesResult
from mailslurp_client.models.email_validation_request import EmailValidationRequest
from mailslurp_client.models.email_verification_result import EmailVerificationResult
from mailslurp_client.models.emergency_address import EmergencyAddress
from mailslurp_client.models.emergency_address_dto import EmergencyAddressDto
from mailslurp_client.models.empty_response_dto import EmptyResponseDto
from mailslurp_client.models.expiration_defaults import ExpirationDefaults
from mailslurp_client.models.expired_inbox_dto import ExpiredInboxDto
from mailslurp_client.models.expired_inbox_record_projection import ExpiredInboxRecordProjection
from mailslurp_client.models.export_link import ExportLink
from mailslurp_client.models.export_options import ExportOptions
from mailslurp_client.models.filter_bounced_recipients_options import FilterBouncedRecipientsOptions
from mailslurp_client.models.filter_bounced_recipients_result import FilterBouncedRecipientsResult
from mailslurp_client.models.flush_expired_inboxes_result import FlushExpiredInboxesResult
from mailslurp_client.models.forward_email_options import ForwardEmailOptions
from mailslurp_client.models.gravatar_url import GravatarUrl
from mailslurp_client.models.group_contacts_dto import GroupContactsDto
from mailslurp_client.models.group_dto import GroupDto
from mailslurp_client.models.group_projection import GroupProjection
from mailslurp_client.models.html_validation_result import HTMLValidationResult
from mailslurp_client.models.ip_address_result import IPAddressResult
from mailslurp_client.models.imap_flag_operation_options import ImapFlagOperationOptions
from mailslurp_client.models.imap_smtp_access_details import ImapSmtpAccessDetails
from mailslurp_client.models.inbox_by_email_address_result import InboxByEmailAddressResult
from mailslurp_client.models.inbox_dto import InboxDto
from mailslurp_client.models.inbox_exists_dto import InboxExistsDto
from mailslurp_client.models.inbox_forwarder_dto import InboxForwarderDto
from mailslurp_client.models.inbox_forwarder_test_options import InboxForwarderTestOptions
from mailslurp_client.models.inbox_forwarder_test_result import InboxForwarderTestResult
from mailslurp_client.models.inbox_id_item import InboxIdItem
from mailslurp_client.models.inbox_ids_result import InboxIdsResult
from mailslurp_client.models.inbox_preview import InboxPreview
from mailslurp_client.models.inbox_ruleset_dto import InboxRulesetDto
from mailslurp_client.models.inbox_ruleset_test_options import InboxRulesetTestOptions
from mailslurp_client.models.inbox_ruleset_test_result import InboxRulesetTestResult
from mailslurp_client.models.inline_object import InlineObject
from mailslurp_client.models.inline_object1 import InlineObject1
from mailslurp_client.models.json_schema_dto import JSONSchemaDto
from mailslurp_client.models.match_option import MatchOption
from mailslurp_client.models.match_options import MatchOptions
from mailslurp_client.models.missed_email import MissedEmail
from mailslurp_client.models.missed_email_projection import MissedEmailProjection
from mailslurp_client.models.name_server_record import NameServerRecord
from mailslurp_client.models.organization_inbox_projection import OrganizationInboxProjection
from mailslurp_client.models.page_alias import PageAlias
from mailslurp_client.models.page_attachment_entity import PageAttachmentEntity
from mailslurp_client.models.page_bounced_email import PageBouncedEmail
from mailslurp_client.models.page_bounced_recipients import PageBouncedRecipients
from mailslurp_client.models.page_contact_projection import PageContactProjection
from mailslurp_client.models.page_email_preview import PageEmailPreview
from mailslurp_client.models.page_email_projection import PageEmailProjection
from mailslurp_client.models.page_email_validation_request import PageEmailValidationRequest
from mailslurp_client.models.page_expired_inbox_record_projection import PageExpiredInboxRecordProjection
from mailslurp_client.models.page_group_projection import PageGroupProjection
from mailslurp_client.models.page_inbox_forwarder_dto import PageInboxForwarderDto
from mailslurp_client.models.page_inbox_projection import PageInboxProjection
from mailslurp_client.models.page_inbox_ruleset_dto import PageInboxRulesetDto
from mailslurp_client.models.page_missed_email_projection import PageMissedEmailProjection
from mailslurp_client.models.page_organization_inbox_projection import PageOrganizationInboxProjection
from mailslurp_client.models.page_phone_number_projection import PagePhoneNumberProjection
from mailslurp_client.models.page_sent_email_projection import PageSentEmailProjection
from mailslurp_client.models.page_sent_email_with_queue_projection import PageSentEmailWithQueueProjection
from mailslurp_client.models.page_sms_projection import PageSmsProjection
from mailslurp_client.models.page_template_projection import PageTemplateProjection
from mailslurp_client.models.page_thread_projection import PageThreadProjection
from mailslurp_client.models.page_tracking_pixel_projection import PageTrackingPixelProjection
from mailslurp_client.models.page_unknown_missed_email_projection import PageUnknownMissedEmailProjection
from mailslurp_client.models.page_webhook_projection import PageWebhookProjection
from mailslurp_client.models.page_webhook_result import PageWebhookResult
from mailslurp_client.models.pageable_object import PageableObject
from mailslurp_client.models.phone_number_dto import PhoneNumberDto
from mailslurp_client.models.phone_number_projection import PhoneNumberProjection
from mailslurp_client.models.phone_plan_dto import PhonePlanDto
from mailslurp_client.models.raw_email_json import RawEmailJson
from mailslurp_client.models.recipient import Recipient
from mailslurp_client.models.reply_to_alias_email_options import ReplyToAliasEmailOptions
from mailslurp_client.models.reply_to_email_options import ReplyToEmailOptions
from mailslurp_client.models.send_email_options import SendEmailOptions
from mailslurp_client.models.send_smtp_envelope_options import SendSMTPEnvelopeOptions
from mailslurp_client.models.send_with_queue_result import SendWithQueueResult
from mailslurp_client.models.sender import Sender
from mailslurp_client.models.sent_email_dto import SentEmailDto
from mailslurp_client.models.sent_email_projection import SentEmailProjection
from mailslurp_client.models.set_inbox_favourited_options import SetInboxFavouritedOptions
from mailslurp_client.models.simple_send_email_options import SimpleSendEmailOptions
from mailslurp_client.models.sms_match_option import SmsMatchOption
from mailslurp_client.models.sms_message import SmsMessage
from mailslurp_client.models.sms_preview import SmsPreview
from mailslurp_client.models.sms_projection import SmsProjection
from mailslurp_client.models.sort import Sort
from mailslurp_client.models.template_dto import TemplateDto
from mailslurp_client.models.template_projection import TemplateProjection
from mailslurp_client.models.template_variable import TemplateVariable
from mailslurp_client.models.test_new_inbox_forwarder_options import TestNewInboxForwarderOptions
from mailslurp_client.models.test_new_inbox_ruleset_options import TestNewInboxRulesetOptions
from mailslurp_client.models.thread_projection import ThreadProjection
from mailslurp_client.models.tracking_pixel_dto import TrackingPixelDto
from mailslurp_client.models.tracking_pixel_projection import TrackingPixelProjection
from mailslurp_client.models.unknown_missed_email_projection import UnknownMissedEmailProjection
from mailslurp_client.models.unread_count import UnreadCount
from mailslurp_client.models.unseen_error_count_dto import UnseenErrorCountDto
from mailslurp_client.models.update_alias_options import UpdateAliasOptions
from mailslurp_client.models.update_domain_options import UpdateDomainOptions
from mailslurp_client.models.update_group_contacts import UpdateGroupContacts
from mailslurp_client.models.update_inbox_options import UpdateInboxOptions
from mailslurp_client.models.upload_attachment_options import UploadAttachmentOptions
from mailslurp_client.models.validate_email_address_list_options import ValidateEmailAddressListOptions
from mailslurp_client.models.validate_email_address_list_result import ValidateEmailAddressListResult
from mailslurp_client.models.validation_dto import ValidationDto
from mailslurp_client.models.validation_message import ValidationMessage
from mailslurp_client.models.verify_email_address_options import VerifyEmailAddressOptions
from mailslurp_client.models.verify_webhook_signature_options import VerifyWebhookSignatureOptions
from mailslurp_client.models.verify_webhook_signature_results import VerifyWebhookSignatureResults
from mailslurp_client.models.wait_for_conditions import WaitForConditions
from mailslurp_client.models.wait_for_sms_conditions import WaitForSmsConditions
from mailslurp_client.models.webhook_bounce_payload import WebhookBouncePayload
from mailslurp_client.models.webhook_bounce_recipient_payload import WebhookBounceRecipientPayload
from mailslurp_client.models.webhook_dto import WebhookDto
from mailslurp_client.models.webhook_email_opened_payload import WebhookEmailOpenedPayload
from mailslurp_client.models.webhook_email_read_payload import WebhookEmailReadPayload
from mailslurp_client.models.webhook_new_attachment_payload import WebhookNewAttachmentPayload
from mailslurp_client.models.webhook_new_contact_payload import WebhookNewContactPayload
from mailslurp_client.models.webhook_new_email_payload import WebhookNewEmailPayload
from mailslurp_client.models.webhook_projection import WebhookProjection
from mailslurp_client.models.webhook_redrive_result import WebhookRedriveResult
from mailslurp_client.models.webhook_result_dto import WebhookResultDto
from mailslurp_client.models.webhook_test_request import WebhookTestRequest
from mailslurp_client.models.webhook_test_response import WebhookTestResponse
from mailslurp_client.models.webhook_test_result import WebhookTestResult

